require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_ASM_H_)) {
    eval 'sub _MACHINE_ASM_H_ () {1;}' unless defined(&_MACHINE_ASM_H_);
    require 'sys/cdefs.ph';
    if(defined(&PIC)) {
	eval 'sub PIC_PROLOGUE () { &pushl % &ebx;  &call 1 &f; 1:  &popl % &ebx;  &addl $ &_GLOBAL_OFFSET_TABLE_+[.-1 &b],% &ebx;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () { &popl % &ebx;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x@ &PLT);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOT {
	    my($x) = @_;
    	    eval q($x@ &GOT(% &ebx));
	}' unless defined(&PIC_GOT);
	eval 'sub PIC_GOTOFF {
	    my($x) = @_;
    	    eval q($x@ &GOTOFF(% &ebx));
	}' unless defined(&PIC_GOTOFF);
    } else {
	eval 'sub PIC_PROLOGUE () {1;}' unless defined(&PIC_PROLOGUE);
	eval 'sub PIC_EPILOGUE () {1;}' unless defined(&PIC_EPILOGUE);
	eval 'sub PIC_PLT {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_PLT);
	eval 'sub PIC_GOTOFF {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&PIC_GOTOFF);
    }
    eval 'sub CNAME {
        my($csym) = @_;
	    eval q($csym);
    }' unless defined(&CNAME);
    eval 'sub HIDENAME {
        my($asmsym) = @_;
	    eval q(.$asmsym);
    }' unless defined(&HIDENAME);
    eval 'sub _START_ENTRY () {. &text; . &p2align 2,0x90;}' unless defined(&_START_ENTRY);
    eval 'sub _ENTRY {
        my($x) = @_;
	    eval q( &_START_ENTRY; . &globl  &CNAME($x); . &type  &CNAME($x),@ &function;  &CNAME($x):);
    }' unless defined(&_ENTRY);
    eval 'sub END {
        my($x) = @_;
	    eval q(. &size $x, . - $x);
    }' unless defined(&END);
    if(defined(&PROF)) {
	eval 'sub ALTENTRY {
	    my($x) = @_;
    	    eval q( &_ENTRY($x);  &pushl % &ebp;  &movl % &esp,% &ebp;  &call  &PIC_PLT( &HIDENAME( &mcount));  &popl % &ebp;  &jmp 9 &f);
	}' unless defined(&ALTENTRY);
	eval 'sub ENTRY {
	    my($x) = @_;
    	    eval q( &_ENTRY($x);  &pushl % &ebp;  &movl % &esp,% &ebp;  &call  &PIC_PLT( &HIDENAME( &mcount));  &popl % &ebp; 9:);
	}' unless defined(&ENTRY);
    } else {
	eval 'sub ALTENTRY {
	    my($x) = @_;
    	    eval q( &_ENTRY($x));
	}' unless defined(&ALTENTRY);
	eval 'sub ENTRY {
	    my($x) = @_;
    	    eval q( &_ENTRY($x));
	}' unless defined(&ENTRY);
    }
    eval 'sub WEAK_REFERENCE {
        my($sym, $alias) = @_;
	    eval q(. &weak  &CNAME($alias); . &equ  &CNAME($alias), &CNAME($sym));
    }' unless defined(&WEAK_REFERENCE);
    eval 'sub STRONG_ALIAS {
        my($alias,$sym) = @_;
	    eval q(. &globl $alias; $alias = $sym);
    }' unless defined(&STRONG_ALIAS);
    eval 'sub RCSID {
        my($x) = @_;
	    eval q(. &text; . &asciz $x);
    }' unless defined(&RCSID);
    undef(&__FBSDID) if defined(&__FBSDID);
    if(!defined(&lint)  && !defined(&STRIP_FBSDID)) {
	eval 'sub __FBSDID {
	    my($s) = @_;
    	    eval q(. &ident $s);
	}' unless defined(&__FBSDID);
    } else {
	eval 'sub __FBSDID {
	    my($s) = @_;
    	    eval q();
	}' unless defined(&__FBSDID);
    }
}
1;
