require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__MACHINE_COUNTER_H__)) {
    eval 'sub __MACHINE_COUNTER_H__ () {1;}' unless defined(&__MACHINE_COUNTER_H__);
    require 'sys/pcpu.ph';
    if(defined(&INVARIANTS)) {
	require 'sys/proc.ph';
    }
    require 'machine/md_var.ph';
    require 'machine/specialreg.ph';
    eval 'sub counter_enter () {
        eval q( &do {  &if (( &cpu_feature &  &CPUID_CX8) == 0)  &critical_enter(); }  &while (0));
    }' unless defined(&counter_enter);
    eval 'sub counter_exit () {
        eval q( &do {  &if (( &cpu_feature &  &CPUID_CX8) == 0)  &critical_exit(); }  &while (0));
    }' unless defined(&counter_exit);
    eval 'sub counter_64_inc_8b {
        my($p,$inc) = @_;
	    eval q({  &__asm  &__volatile( \\"movl	%%fs:(%%esi),%%eax\\\\n\\\\t\\" \\"movl	%%fs:4(%%esi),%%edx\\\\n\\" \\"1:\\\\n\\\\t\\" \\"movl	%%eax,%%ebx\\\\n\\\\t\\" \\"movl	%%edx,%%ecx\\\\n\\\\t\\" \\"addl	(%%edi),%%ebx\\\\n\\\\t\\" \\"adcl	4(%%edi),%%ecx\\\\n\\\\t\\" \\"cmpxchg8b %%fs:(%%esi)\\\\n\\\\t\\" \\"jnz	1b\\" : : \\"S\\" ($p - & $__pcpu[0]), \\"D\\" ($inc) : \\"memory\\", \\"cc\\", \\"eax\\", \\"edx\\", \\"ebx\\", \\"ecx\\"); });
    }' unless defined(&counter_64_inc_8b);
    if(defined(&IN_SUBR_COUNTER_C)) {
	eval 'sub counter_u64_read_one_8b {
	    my($p) = @_;
    	    eval q({  &uint32_t  &res_lo,  &res_high;  &__asm  &__volatile( \\"movl	%%eax,%%ebx\\\\n\\\\t\\" \\"movl	%%edx,%%ecx\\\\n\\\\t\\" \\"cmpxchg8b	(%2)\\" : \\"=a\\" ( &res_lo), \\"=d\\"( &res_high) : \\"SD\\" ($p) : \\"cc\\", \\"ebx\\", \\"ecx\\"); ( &res_lo + (( &uint64_t) &res_high << 32)); });
	}' unless defined(&counter_u64_read_one_8b);
	eval 'sub counter_u64_fetch_inline {
	    my($p) = @_;
    	    eval q({  &uint64_t  &res; \'int\'  &i;  &res = 0;  &if (( &cpu_feature &  &CPUID_CX8) == 0) {  &critical_enter();  &CPU_FOREACH( &i) {  &res += *( &uint64_t *)($p + $sizeof{\'struct pcpu\'} *  &i); }  &critical_exit(); }  &else {  &CPU_FOREACH( &i)  &res +=  &counter_u64_read_one_8b(( &uint64_t *)($p + $sizeof{\'struct pcpu\'} *  &i)); } ( &res); });
	}' unless defined(&counter_u64_fetch_inline);
	eval 'sub counter_u64_zero_one_8b {
	    my($p) = @_;
    	    eval q({  &__asm  &__volatile( \\"movl	(%0),%%eax\\\\n\\\\t\\" \\"movl	4(%0),%%edx\\\\n\\" \\"xorl	%%ebx,%%ebx\\\\n\\\\t\\" \\"xorl	%%ecx,%%ecx\\\\n\\\\t\\" \\"1:\\\\n\\\\t\\" \\"cmpxchg8b	(%0)\\\\n\\\\t\\" \\"jnz	1b\\" : : \\"SD\\" ($p) : \\"memory\\", \\"cc\\", \\"eax\\", \\"edx\\", \\"ebx\\", \\"ecx\\"); });
	}' unless defined(&counter_u64_zero_one_8b);
	eval 'sub counter_u64_zero_inline {
	    my($c) = @_;
    	    eval q({ \'int\'  &i;  &if (( &cpu_feature &  &CPUID_CX8) == 0) {  &critical_enter();  &CPU_FOREACH( &i) *( &uint64_t *)($c + $sizeof{\'struct pcpu\'} *  &i) = 0;  &critical_exit(); }  &else {  &smp_rendezvous( &smp_no_rendevous_barrier,  &counter_u64_zero_one_cpu,  &smp_no_rendevous_barrier, $c); } });
	}' unless defined(&counter_u64_zero_inline);
    }
    eval 'sub counter_u64_add_protected {
        my($c, $inc) = @_;
	    eval q( &do {  &if (( &cpu_feature &  &CPUID_CX8) == 0) {  &CRITICAL_ASSERT( &curthread); *( &uint64_t *) &zpcpu_get($c) += ($inc); }  &else  &counter_64_inc_8b(($c), ($inc)); }  &while (0));
    }' unless defined(&counter_u64_add_protected);
    eval 'sub counter_u64_add {
        my($c,$inc) = @_;
	    eval q({  &if (( &cpu_feature &  &CPUID_CX8) == 0) {  &critical_enter(); *( &uint64_t *) &zpcpu_get($c) += $inc;  &critical_exit(); }  &else {  &counter_64_inc_8b($c, $inc); } });
    }' unless defined(&counter_u64_add);
}
1;
