require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_PCPU_H_)) {
    eval 'sub _MACHINE_PCPU_H_ () {1;}' unless defined(&_MACHINE_PCPU_H_);
    unless(defined(&_SYS_CDEFS_H_)) {
	die("sys/cdefs.h is a prerequisite for this file");
    }
    require 'machine/segments.ph';
    require 'machine/tss.ph';
    require 'sys/_lock.ph';
    require 'sys/_mutex.ph';
    eval 'sub PCPU_MD_FIELDS () {\'char\'  $pc_monitorbuf[128]  &__aligned(128); \'struct pcpu\' * &pc_prvspace; \'struct pmap\' * &pc_curpmap; \'struct i386tss\'  &pc_common_tss; \'struct segment_descriptor\'  &pc_common_tssd; \'struct segment_descriptor\' * &pc_tss_gdt; \'struct segment_descriptor\' * &pc_fsgs_gdt; \'int\'  &pc_currentldt; \'u_int\'  &pc_acpi_id; \'u_int\'  &pc_apic_id; \'int\'  &pc_private_tss; \'u_int\'  &pc_cmci_mask; \'u_int\'  &pc_vcpu_id; \'struct mtx\'  &pc_cmap_lock;  &void * &pc_cmap_pte1;  &void * &pc_cmap_pte2; \'caddr_t\'  &pc_cmap_addr1; \'caddr_t\'  &pc_cmap_addr2;  &vm_offset_t  &pc_qmap_addr;  &uint32_t  &pc_smp_tlb_done; \'char\'  $__pad[189];}' unless defined(&PCPU_MD_FIELDS);
    if(defined(&_KERNEL)) {
	if(defined(&lint)) {
	    eval 'sub get_pcpu () {
	        eval q(( &pcpup));
	    }' unless defined(&get_pcpu);
	    eval 'sub PCPU_GET {
	        my($member) = @_;
    		eval q(( ($pcpup->{pc_})  $member));
	    }' unless defined(&PCPU_GET);
	    eval 'sub PCPU_ADD {
	        my($member, $val) = @_;
    		eval q(( ($pcpup->{pc_})  $member += ($val)));
	    }' unless defined(&PCPU_ADD);
	    eval 'sub PCPU_INC {
	        my($member) = @_;
    		eval q( &PCPU_ADD($member, 1));
	    }' unless defined(&PCPU_INC);
	    eval 'sub PCPU_PTR {
	        my($member) = @_;
    		eval q(( ($pcpup->{pc_})  $member));
	    }' unless defined(&PCPU_PTR);
	    eval 'sub PCPU_SET {
	        my($member, $val) = @_;
    		eval q(( ($pcpup->{pc_})  $member = ($val)));
	    }' unless defined(&PCPU_SET);
	}
 elsif(defined(&__GNUCLIKE_ASM)  && defined(&__GNUCLIKE___TYPEOF)) {
	    eval 'sub __pcpu_offset {
	        my($name) = @_;
    		eval q( &__offsetof(\'struct pcpu\', $name));
	    }' unless defined(&__pcpu_offset);
	    eval 'sub __pcpu_type {
	        my($name) = @_;
    		eval q( &__typeof((0)->$name));
	    }' unless defined(&__pcpu_type);
	    eval 'sub __PCPU_PTR {
	        my($name) = @_;
    		eval q( &__extension__ ({  &__pcpu_type($name) * &__p;  &__asm  &__volatile(\\"movl %%fs:%1,%0; addl %2,%0\\" : \\"=r\\" ( &__p) : \\"m\\" (*( &__pcpu_offset( &pc_prvspace))), \\"i\\" ( &__pcpu_offset($name)));  &__p; }));
	    }' unless defined(&__PCPU_PTR);
	    eval 'sub __PCPU_GET {
	        my($name) = @_;
    		eval q( &__extension__ ({  &__pcpu_type($name)  &__res; \'struct __s\' { \'u_char\'  $__b[ &MIN($sizeof{ &__res}, 4)]; }  &__s;  &if ($sizeof{ &__res} == 1|| $sizeof{ &__res} == 2|| $sizeof{ &__res} == 4) {  &__asm  &__volatile(\\"mov %%fs:%1,%0\\" : \\"=r\\" ( &__s) : \\"m\\" (*( &__pcpu_offset($name)))); *( &void *)& &__res =  &__s; }  &else {  &__res = * &__PCPU_PTR($name); }  &__res; }));
	    }' unless defined(&__PCPU_GET);
	    eval 'sub __PCPU_ADD {
	        my($name, $val) = @_;
    		eval q( &do {  &__pcpu_type($name)  &__val; \'struct __s\' { \'u_char\'  $__b[ &MIN($sizeof{ &__val}, 4)]; }  &__s;  &__val = ($val);  &if ($sizeof{ &__val} == 1|| $sizeof{ &__val} == 2|| $sizeof{ &__val} == 4) {  &__s = *( &void *)& &__val;  &__asm  &__volatile(\\"add %1,%%fs:%0\\" : \\"=m\\" (*( &__pcpu_offset($name))) : \\"r\\" ( &__s)); }  &else * &__PCPU_PTR($name) +=  &__val; }  &while (0));
	    }' unless defined(&__PCPU_ADD);
	    eval 'sub __PCPU_INC {
	        my($name) = @_;
    		eval q( &do {  &CTASSERT($sizeof{ &__pcpu_type($name)} == 1|| $sizeof{ &__pcpu_type($name)} == 2|| $sizeof{ &__pcpu_type($name)} == 4);  &if ($sizeof{ &__pcpu_type($name)} == 1) {  &__asm  &__volatile(\\"incb %%fs:%0\\" : \\"=m\\" (*( &__pcpu_type($name) *)( &__pcpu_offset($name))) : \\"m\\" (*( &__pcpu_type($name) *)( &__pcpu_offset($name)))); }  &else  &if ($sizeof{ &__pcpu_type($name)} == 2) {  &__asm  &__volatile(\\"incw %%fs:%0\\" : \\"=m\\" (*( &__pcpu_type($name) *)( &__pcpu_offset($name))) : \\"m\\" (*( &__pcpu_type($name) *)( &__pcpu_offset($name)))); }  &else  &if ($sizeof{ &__pcpu_type($name)} == 4) {  &__asm  &__volatile(\\"incl %%fs:%0\\" : \\"=m\\" (*( &__pcpu_type($name) *)( &__pcpu_offset($name))) : \\"m\\" (*( &__pcpu_type($name) *)( &__pcpu_offset($name)))); } }  &while (0));
	    }' unless defined(&__PCPU_INC);
	    eval 'sub __PCPU_SET {
	        my($name, $val) = @_;
    		eval q( &do {  &__pcpu_type($name)  &__val; \'struct __s\' { \'u_char\'  $__b[ &MIN($sizeof{ &__val}, 4)]; }  &__s;  &__val = ($val);  &if ($sizeof{ &__val} == 1|| $sizeof{ &__val} == 2|| $sizeof{ &__val} == 4) {  &__s = *( &void *)& &__val;  &__asm  &__volatile(\\"mov %1,%%fs:%0\\" : \\"=m\\" (*( &__pcpu_offset($name))) : \\"r\\" ( &__s)); }  &else { * &__PCPU_PTR($name) =  &__val; } }  &while (0));
	    }' unless defined(&__PCPU_SET);
	    eval 'sub get_pcpu () {
	        eval q( &__extension__ ({ \'struct pcpu\' * &__pc;  &__asm  &__volatile(\\"movl %%fs:%1,%0\\" : \\"=r\\" ( &__pc) : \\"m\\" (*( &__pcpu_offset( &pc_prvspace))));  &__pc; }));
	    }' unless defined(&get_pcpu);
	    eval 'sub PCPU_GET {
	        my($member) = @_;
    		eval q( &__PCPU_GET( &pc_  $member));
	    }' unless defined(&PCPU_GET);
	    eval 'sub PCPU_ADD {
	        my($member, $val) = @_;
    		eval q( &__PCPU_ADD( &pc_  $member, $val));
	    }' unless defined(&PCPU_ADD);
	    eval 'sub PCPU_INC {
	        my($member) = @_;
    		eval q( &__PCPU_INC( &pc_  $member));
	    }' unless defined(&PCPU_INC);
	    eval 'sub PCPU_PTR {
	        my($member) = @_;
    		eval q( &__PCPU_PTR( &pc_  $member));
	    }' unless defined(&PCPU_PTR);
	    eval 'sub PCPU_SET {
	        my($member, $val) = @_;
    		eval q( &__PCPU_SET( &pc_  $member, $val));
	    }' unless defined(&PCPU_SET);
	    eval 'sub OFFSETOF_CURTHREAD () {0;}' unless defined(&OFFSETOF_CURTHREAD);
	    if(defined(&__clang__)) {
	    }
	    eval 'sub __curthread {
	        my($void) = @_;
    		eval q({ \'struct thread\' * &td;  &__asm(\\"movl %%fs:%1,%0\\" : \\"=r\\" : \\"m\\" (* &OFFSETOF_CURTHREAD)); ( &td); });
	    }' unless defined(&__curthread);
	    if(defined(&__clang__)) {
	    }
	    eval 'sub curthread () {( &__curthread());}' unless defined(&curthread);
	    eval 'sub OFFSETOF_CURPCB () {16;}' unless defined(&OFFSETOF_CURPCB);
	    eval 'sub __curpcb {
	        my($void) = @_;
    		eval q({ \'struct pcb\' * &pcb;  &__asm(\\"movl %%fs:%1,%0\\" : \\"=r\\" : \\"m\\" (* &OFFSETOF_CURPCB)); ( &pcb); });
	    }' unless defined(&__curpcb);
	    eval 'sub curpcb () {( &__curpcb());}' unless defined(&curpcb);
	} else {
	    die("this file needs to be ported to your compiler");
	}
    }
}
1;
