require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_FILEDESC_H_)) {
    eval 'sub _SYS_FILEDESC_H_ () {1;}' unless defined(&_SYS_FILEDESC_H_);
    require 'sys/caprights.ph';
    require 'sys/queue.ph';
    require 'sys/event.ph';
    require 'sys/lock.ph';
    require 'sys/priority.ph';
    require 'sys/seq.ph';
    require 'sys/sx.ph';
    require 'machine/_limits.ph';
    eval 'sub fde_rights () { ($fde_caps->{fc_rights});}' unless defined(&fde_rights);
    eval 'sub fde_fcntls () { ($fde_caps->{fc_fcntls});}' unless defined(&fde_fcntls);
    eval 'sub fde_ioctls () { ($fde_caps->{fc_ioctls});}' unless defined(&fde_ioctls);
    eval 'sub fde_nioctls () { ($fde_caps->{fc_nioctls});}' unless defined(&fde_nioctls);
    eval 'sub fde_change_size () {( &offsetof(\'struct filedescent\',  &fde_seq));}' unless defined(&fde_change_size);
    eval 'sub fd_seq {
        my($fdt, $fd) = @_;
	    eval q((($fdt)-> ($fdt_ofiles[&(fd)]->{fde_seq})));
    }' unless defined(&fd_seq);
    eval 'sub NDSLOTTYPE () {\'u_long\';}' unless defined(&NDSLOTTYPE);
    eval 'sub fd_nfiles () { ($fd_files->{fdt_nfiles});}' unless defined(&fd_nfiles);
    eval 'sub fd_ofiles () { ($fd_files->{fdt_ofiles});}' unless defined(&fd_ofiles);
    eval 'sub UF_EXCLOSE () {0x1;}' unless defined(&UF_EXCLOSE);
    if(defined(&_KERNEL)) {
	eval 'sub FILEDESC_LOCK_INIT {
	    my($fdp) = @_;
    	    eval q( &sx_init(($fdp)-> &fd_sx, \\"filedesc structure\\"));
	}' unless defined(&FILEDESC_LOCK_INIT);
	eval 'sub FILEDESC_LOCK_DESTROY {
	    my($fdp) = @_;
    	    eval q( &sx_destroy(($fdp)-> &fd_sx));
	}' unless defined(&FILEDESC_LOCK_DESTROY);
	eval 'sub FILEDESC_LOCK {
	    my($fdp) = @_;
    	    eval q((($fdp)-> &fd_sx));
	}' unless defined(&FILEDESC_LOCK);
	eval 'sub FILEDESC_XLOCK {
	    my($fdp) = @_;
    	    eval q( &sx_xlock(($fdp)-> &fd_sx));
	}' unless defined(&FILEDESC_XLOCK);
	eval 'sub FILEDESC_XUNLOCK {
	    my($fdp) = @_;
    	    eval q( &sx_xunlock(($fdp)-> &fd_sx));
	}' unless defined(&FILEDESC_XUNLOCK);
	eval 'sub FILEDESC_SLOCK {
	    my($fdp) = @_;
    	    eval q( &sx_slock(($fdp)-> &fd_sx));
	}' unless defined(&FILEDESC_SLOCK);
	eval 'sub FILEDESC_SUNLOCK {
	    my($fdp) = @_;
    	    eval q( &sx_sunlock(($fdp)-> &fd_sx));
	}' unless defined(&FILEDESC_SUNLOCK);
	eval 'sub FILEDESC_LOCK_ASSERT {
	    my($fdp) = @_;
    	    eval q( &sx_assert(($fdp)-> &fd_sx,  &SX_LOCKED |  &SX_NOTRECURSED));
	}' unless defined(&FILEDESC_LOCK_ASSERT);
	eval 'sub FILEDESC_XLOCK_ASSERT {
	    my($fdp) = @_;
    	    eval q( &sx_assert(($fdp)-> &fd_sx,  &SX_XLOCKED |  &SX_NOTRECURSED));
	}' unless defined(&FILEDESC_XLOCK_ASSERT);
	eval 'sub FILEDESC_UNLOCK_ASSERT {
	    my($fdp) = @_;
    	    eval q( &sx_assert(($fdp)-> &fd_sx,  &SX_UNLOCKED));
	}' unless defined(&FILEDESC_UNLOCK_ASSERT);
	eval("sub FDDUP_NORMAL () { 0; }") unless defined(&FDDUP_NORMAL);
	eval("sub FDDUP_FCNTL () { 1; }") unless defined(&FDDUP_FCNTL);
	eval("sub FDDUP_FIXED () { 2; }") unless defined(&FDDUP_FIXED);
	eval("sub FDDUP_MUSTREPLACE () { 3; }") unless defined(&FDDUP_MUSTREPLACE);
	eval("sub FDDUP_LASTMODE () { 4; }") unless defined(&FDDUP_LASTMODE);
	eval 'sub FDDUP_FLAG_CLOEXEC () {0x1;}' unless defined(&FDDUP_FLAG_CLOEXEC);
	eval 'sub falloc {
	    my($td, $resultfp, $resultfd, $flags) = @_;
    	    eval q( &falloc_caps($td, $resultfp, $resultfd, $flags,  &NULL));
	}' unless defined(&falloc);
	eval 'sub fdeget_locked {
	    my($fdp,$fd) = @_;
    	    eval q({ \'struct filedescent\' * &fde;  &FILEDESC_LOCK_ASSERT;  &if ($fd >  ($fdp->{fd_lastfile})) ( &NULL);  &fde =  ($fdp->{fd_ofiles[$fd]});  &if ( ($fde->{fde_file}) ==  &NULL) ( &NULL); ( &fde); });
	}' unless defined(&fdeget_locked);
	eval 'sub fd_modified {
	    my($fdp,$fd,$seq) = @_;
    	    eval q({ (! &seq_consistent( &fd_seq( ($fdp->{fd_files}), $fd), $seq)); });
	}' unless defined(&fd_modified);
    }
}
1;
