require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_GPT_H_)) {
    eval 'sub _SYS_GPT_H_ () {1;}' unless defined(&_SYS_GPT_H_);
    require 'sys/uuid.ph';
    eval 'sub GPT_HDR_SIG () {"EFI PART";}' unless defined(&GPT_HDR_SIG);
    eval 'sub GPT_HDR_REVISION () {0x10000;}' unless defined(&GPT_HDR_REVISION);
    eval 'sub GPT_ENT_ATTR_PLATFORM () {(1 << 0);}' unless defined(&GPT_ENT_ATTR_PLATFORM);
    eval 'sub GPT_ENT_ATTR_BOOTME () {(1 << 59);}' unless defined(&GPT_ENT_ATTR_BOOTME);
    eval 'sub GPT_ENT_ATTR_BOOTONCE () {(1 << 58);}' unless defined(&GPT_ENT_ATTR_BOOTONCE);
    eval 'sub GPT_ENT_ATTR_BOOTFAILED () {(1 << 57);}' unless defined(&GPT_ENT_ATTR_BOOTFAILED);
    eval 'sub GPT_ENT_TYPE_UNUSED () {{0x,0x,0x,0x,0x,{0x,0x,0x,0x,0x,0x}};}' unless defined(&GPT_ENT_TYPE_UNUSED);
    eval 'sub GPT_ENT_TYPE_EFI () {{0xc12a7328,0xf81f,0x11d2,0xba,0x4b,{0x,0xa0,0xc9,0x3e,0xc9,0x3b}};}' unless defined(&GPT_ENT_TYPE_EFI);
    eval 'sub GPT_ENT_TYPE_MBR () {{0x24dee41,0x33e7,0x11d3,0x9d,0x69,{0x,0x8,0xc7,0x81,0xf3,0x9f}};}' unless defined(&GPT_ENT_TYPE_MBR);
    eval 'sub GPT_ENT_TYPE_FREEBSD () {{0x516e7cb4,0x6ecf,0x11d6,0x8f,0xf8,{0x,0x2,0x2d,0x9,0x71,0x2b}};}' unless defined(&GPT_ENT_TYPE_FREEBSD);
    eval 'sub GPT_ENT_TYPE_FREEBSD_BOOT () {{0x83bd6b9d,0x7f41,0x11dc,0xbe,0xb,{0x,0x15,0x60,0xb8,0x4f,0xf}};}' unless defined(&GPT_ENT_TYPE_FREEBSD_BOOT);
    eval 'sub GPT_ENT_TYPE_FREEBSD_NANDFS () {{0x74ba7dd9,0xa689,0x11e1,0xbd,0x4,{0x,0xe0,0x81,0x28,0x6a,0xcf}};}' unless defined(&GPT_ENT_TYPE_FREEBSD_NANDFS);
    eval 'sub GPT_ENT_TYPE_FREEBSD_SWAP () {{0x516e7cb5,0x6ecf,0x11d6,0x8f,0xf8,{0x,0x2,0x2d,0x9,0x71,0x2b}};}' unless defined(&GPT_ENT_TYPE_FREEBSD_SWAP);
    eval 'sub GPT_ENT_TYPE_FREEBSD_UFS () {{0x516e7cb6,0x6ecf,0x11d6,0x8f,0xf8,{0x,0x2,0x2d,0x9,0x71,0x2b}};}' unless defined(&GPT_ENT_TYPE_FREEBSD_UFS);
    eval 'sub GPT_ENT_TYPE_FREEBSD_VINUM () {{0x516e7cb8,0x6ecf,0x11d6,0x8f,0xf8,{0x,0x2,0x2d,0x9,0x71,0x2b}};}' unless defined(&GPT_ENT_TYPE_FREEBSD_VINUM);
    eval 'sub GPT_ENT_TYPE_FREEBSD_ZFS () {{0x516e7cba,0x6ecf,0x11d6,0x8f,0xf8,{0x,0x2,0x2d,0x9,0x71,0x2b}};}' unless defined(&GPT_ENT_TYPE_FREEBSD_ZFS);
    eval 'sub GPT_ENT_TYPE_PREP_BOOT () {{0x9e1a2d38,0xc612,0x4316,0xaa,0x26,{0x8b,0x49,0x52,0x1e,0x5a,0x8b}};}' unless defined(&GPT_ENT_TYPE_PREP_BOOT);
    eval 'sub GPT_ENT_TYPE_MS_BASIC_DATA () {{0xebd0a0a2,0xb9e5,0x4433,0x87,0xc0,{0x68,0xb6,0xb7,0x26,0x99,0xc7}};}' unless defined(&GPT_ENT_TYPE_MS_BASIC_DATA);
    eval 'sub GPT_ENT_TYPE_MS_LDM_DATA () {{0xaf9b60a0,0x1431,0x4f62,0xbc,0x68,{0x33,0x11,0x71,0x4a,0x69,0xad}};}' unless defined(&GPT_ENT_TYPE_MS_LDM_DATA);
    eval 'sub GPT_ENT_TYPE_MS_LDM_METADATA () {{0x5808c8aa,0x7e8f,0x42e0,0x85,0xd2,{0xe1,0xe9,0x4,0x34,0xcf,0xb3}};}' unless defined(&GPT_ENT_TYPE_MS_LDM_METADATA);
    eval 'sub GPT_ENT_TYPE_MS_RECOVERY () {{0xde94bba4,0x6d1,0x4d40,0xa1,0x6a,{0xbf,0xd5,0x1,0x79,0xd6,0xac}};}' unless defined(&GPT_ENT_TYPE_MS_RECOVERY);
    eval 'sub GPT_ENT_TYPE_MS_RESERVED () {{0xe3c9e316,0xb5c,0x4db8,0x81,0x7d,{0xf9,0x2d,0xf0,0x2,0x15,0xae}};}' unless defined(&GPT_ENT_TYPE_MS_RESERVED);
    eval 'sub GPT_ENT_TYPE_MS_SPACES () {{0xe75caf8f,0xf680,0x4cee,0xaf,0xa3,{0xb0,0x1,0xe5,0x6e,0xfc,0x2d}};}' unless defined(&GPT_ENT_TYPE_MS_SPACES);
    eval 'sub GPT_ENT_TYPE_LINUX_DATA () {{0xfc63daf,0x8483,0x4772,0x8e,0x79,{0x3d,0x69,0xd8,0x47,0x7d,0xe4}};}' unless defined(&GPT_ENT_TYPE_LINUX_DATA);
    eval 'sub GPT_ENT_TYPE_LINUX_RAID () {{0xa19d880f,0x5fc,0x4d3b,0xa0,0x6,{0x74,0x3f,0xf,0x84,0x91,0x1e}};}' unless defined(&GPT_ENT_TYPE_LINUX_RAID);
    eval 'sub GPT_ENT_TYPE_LINUX_SWAP () {{0x657fd6d,0xa4ab,0x43c4,0x84,0xe5,{0x9,0x33,0xc8,0x4b,0x4f,0x4f}};}' unless defined(&GPT_ENT_TYPE_LINUX_SWAP);
    eval 'sub GPT_ENT_TYPE_LINUX_LVM () {{0xe6d6d379,0xf507,0x44c2,0xa2,0x3c,{0x23,0x8f,0x2a,0x3d,0xf9,0x28}};}' unless defined(&GPT_ENT_TYPE_LINUX_LVM);
    eval 'sub GPT_ENT_TYPE_VMFS () {{0xaa31e02a,0x400f,0x11db,0x95,0x90,{0x,0xc,0x29,0x11,0xd1,0xb8}};}' unless defined(&GPT_ENT_TYPE_VMFS);
    eval 'sub GPT_ENT_TYPE_VMKDIAG () {{0x9d275380,0x40ad,0x11db,0xbf,0x97,{0x,0xc,0x29,0x11,0xd1,0xb8}};}' unless defined(&GPT_ENT_TYPE_VMKDIAG);
    eval 'sub GPT_ENT_TYPE_VMRESERVED () {{0x9198effc,0x31c0,0x11db,0x8f,0x78,{0x,0xc,0x29,0x11,0xd1,0xb8}};}' unless defined(&GPT_ENT_TYPE_VMRESERVED);
    eval 'sub GPT_ENT_TYPE_VMVSANHDR () {{0x381cfccc,0x7288,0x11e0,0x92,0xee,{0x,0xc,0x29,0x11,0xd0,0xb2}};}' unless defined(&GPT_ENT_TYPE_VMVSANHDR);
    eval 'sub GPT_ENT_TYPE_APPLE_BOOT () {{0x426f6f74,0x,0x11aa,0xaa,0x11,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_BOOT);
    eval 'sub GPT_ENT_TYPE_APPLE_HFS () {{0x48465300,0x,0x11aa,0xaa,0x11,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_HFS);
    eval 'sub GPT_ENT_TYPE_APPLE_UFS () {{0x55465300,0x,0x11aa,0xaa,0x11,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_UFS);
    eval 'sub GPT_ENT_TYPE_APPLE_ZFS () {{0x6a898cc3,0x1dd2,0x11b2,0x99,0xa6,{0x8,0x,0x20,0x73,0x66,0x31}};}' unless defined(&GPT_ENT_TYPE_APPLE_ZFS);
    eval 'sub GPT_ENT_TYPE_APPLE_RAID () {{0x52414944,0x,0x11aa,0xaa,0x22,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_RAID);
    eval 'sub GPT_ENT_TYPE_APPLE_RAID_OFFLINE () {{0x52414944,0x5f4f,0x11aa,0xaa,0x22,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_RAID_OFFLINE);
    eval 'sub GPT_ENT_TYPE_APPLE_LABEL () {{0x4c616265,0x6c00,0x11aa,0xaa,0x11,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_LABEL);
    eval 'sub GPT_ENT_TYPE_APPLE_TV_RECOVERY () {{0x5265636f,0x7665,0x11aa,0xaa,0x11,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_TV_RECOVERY);
    eval 'sub GPT_ENT_TYPE_APPLE_CORE_STORAGE () {{0x53746f72,0x6167,0x11aa,0xaa,0x11,{0x,0x30,0x65,0x43,0xec,0xac}};}' unless defined(&GPT_ENT_TYPE_APPLE_CORE_STORAGE);
    eval 'sub GPT_ENT_TYPE_NETBSD_FFS () {{0x49f48d5a,0xb10e,0x11dc,0xb9,0x9b,{0x,0x19,0xd1,0x87,0x96,0x48}};}' unless defined(&GPT_ENT_TYPE_NETBSD_FFS);
    eval 'sub GPT_ENT_TYPE_NETBSD_LFS () {{0x49f48d82,0xb10e,0x11dc,0xb9,0x9b,{0x,0x19,0xd1,0x87,0x96,0x48}};}' unless defined(&GPT_ENT_TYPE_NETBSD_LFS);
    eval 'sub GPT_ENT_TYPE_NETBSD_SWAP () {{0x49f48d32,0xb10e,0x11dc,0xb9,0x9b,{0x,0x19,0xd1,0x87,0x96,0x48}};}' unless defined(&GPT_ENT_TYPE_NETBSD_SWAP);
    eval 'sub GPT_ENT_TYPE_NETBSD_RAID () {{0x49f48daa,0xb10e,0x11dc,0xb9,0x9b,{0x,0x19,0xd1,0x87,0x96,0x48}};}' unless defined(&GPT_ENT_TYPE_NETBSD_RAID);
    eval 'sub GPT_ENT_TYPE_NETBSD_CCD () {{0x2db519c4,0xb10f,0x11dc,0xb9,0x9b,{0x,0x19,0xd1,0x87,0x96,0x48}};}' unless defined(&GPT_ENT_TYPE_NETBSD_CCD);
    eval 'sub GPT_ENT_TYPE_NETBSD_CGD () {{0x2db519ec,0xb10f,0x11dc,0xb9,0x9b,{0x,0x19,0xd1,0x87,0x96,0x48}};}' unless defined(&GPT_ENT_TYPE_NETBSD_CGD);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_LABEL32 () {{0x9d087404,0x1ca5,0x11dc,0x88,0x17,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_LABEL32);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_SWAP () {{0x9d58fdbd,0x1ca5,0x11dc,0x88,0x17,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_SWAP);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_UFS1 () {{0x9d94ce7c,0x1ca5,0x11dc,0x88,0x17,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_UFS1);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_VINUM () {{0x9dd4478f,0x1ca5,0x11dc,0x88,0x17,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_VINUM);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_CCD () {{0xdbd5211b,0x1ca5,0x11dc,0x88,0x17,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_CCD);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_LABEL64 () {{0x3d48ce54,0x1d16,0x11dc,0x86,0x96,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_LABEL64);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_LEGACY () {{0xbd215ab2,0x1d16,0x11dc,0x86,0x96,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_LEGACY);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_HAMMER () {{0x61dc63ac,0x6e38,0x11dc,0x85,0x13,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_HAMMER);
    eval 'sub GPT_ENT_TYPE_DRAGONFLY_HAMMER2 () {{0x5cbb9ad1,0x862d,0x11dc,0xa9,0x4d,{0x1,0x30,0x1b,0xb8,0xa9,0xf5}};}' unless defined(&GPT_ENT_TYPE_DRAGONFLY_HAMMER2);
    eval 'sub GPT_ENT_TYPE_CHROMEOS_FIRMWARE () {{0xcab6e88e,0xabf3,0x4102,0xa0,0x7a,{0xd4,0xbb,0x9b,0xe3,0xc1,0xd3}};}' unless defined(&GPT_ENT_TYPE_CHROMEOS_FIRMWARE);
    eval 'sub GPT_ENT_TYPE_CHROMEOS_KERNEL () {{0xfe3a2a5d,0x4f32,0x41a7,0xb7,0x25,{0xac,0xcc,0x32,0x85,0xa3,0x9}};}' unless defined(&GPT_ENT_TYPE_CHROMEOS_KERNEL);
    eval 'sub GPT_ENT_TYPE_CHROMEOS_RESERVED () {{0x2e0a753d,0x9e48,0x43b0,0x83,0x37,{0xb1,0x51,0x92,0xcb,0x1b,0x5e}};}' unless defined(&GPT_ENT_TYPE_CHROMEOS_RESERVED);
    eval 'sub GPT_ENT_TYPE_CHROMEOS_ROOT () {{0x3cb8e202,0x3b7e,0x47dd,0x8a,0x3c,{0x7f,0xf2,0xa1,0x3c,0xfc,0xec}};}' unless defined(&GPT_ENT_TYPE_CHROMEOS_ROOT);
    eval 'sub GPT_ENT_TYPE_OPENBSD_DATA () {{0x824cc7a0,0x36a8,0x11e3,0x89,0xa,{0x95,0x25,0x19,0xad,0x3f,0x61}};}' unless defined(&GPT_ENT_TYPE_OPENBSD_DATA);
    eval 'sub GPT_ENT_TYPE_BIOS_BOOT () {{0x21686148,0x6449,0x6e6f,0x74,0x4e,{0x65,0x65,0x64,0x45,0x46,0x49}};}' unless defined(&GPT_ENT_TYPE_BIOS_BOOT);
}
1;
